Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.Beta1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.heuristic.selector.entity.mimic
Class MimicReplayingEntitySelector

    java.lang.Object
      org.optaplanner.core.impl.heuristic.selector.AbstractSelector
          org.optaplanner.core.impl.heuristic.selector.entity.AbstractEntitySelector
              org.optaplanner.core.impl.heuristic.selector.entity.mimic.MimicReplayingEntitySelector

All Implemented Interfaces:
  Iterable<Object>, EventListener, ListIterable<Object>, EntitySelector, IterableSelector<Object>, ListIterableSelector<Object>, Selector, SolverPhaseLifecycleListener, SolverLifecycleListener

    public class MimicReplayingEntitySelector

extends AbstractEntitySelector

Field Summary
`protected boolean` | `hasRecording`
`protected boolean` | `hasRecordingCreated`
`protected Object` | `recording`
`protected boolean` | `recordingAlreadyReturned`
`protected boolean` | `recordingCreated`
`protected MimicRecordingEntitySelector` | `recordingEntitySelector`

Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector
`logger, solverPhaseLifecycleSupport, workingRandom`

Constructor Summary
`MimicReplayingEntitySelector(MimicRecordingEntitySelector recordingEntitySelector)`

Method Summary
`Iterator<Object>` | `endingIterator()` If `Selector.isNeverEnding()` is true, then `Iterable.iterator()` will never end.
`PlanningEntityDescriptor` | `getEntityDescriptor()`
`long` | `getSize()` A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
`boolean` | `isCountable()` If false, then `Selector.isNeverEnding()` is true.
`boolean` | `isNeverEnding()` Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases).
`Iterator<Object>` | `iterator()`
`ListIterator<Object>` | `listIterator()` See `List.listIterator()`
`ListIterator<Object>` | `listIterator(int index)` See `List.listIterator()`
`void` | `phaseEnded(AbstractSolverPhaseScope phaseScope)`
`void` | `phaseStarted(AbstractSolverPhaseScope phaseScope)`
`void` | `recordedHasNext(boolean hasNext)`
`void` | `recordedNext(Object next)`
`String` | `toString()`

Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector
`getCacheType, solvingEnded, solvingStarted, stepEnded, stepStarted`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.Selector
`getCacheType`

Methods inherited from interface org.optaplanner.core.impl.phase.event.SolverPhaseLifecycleListener
`stepEnded, stepStarted`

Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener
`solvingEnded, solvingStarted`

Field Detail

### recordingEntitySelector

    protected final MimicRecordingEntitySelector recordingEntitySelector

### hasRecordingCreated

    protected boolean hasRecordingCreated

### hasRecording

    protected boolean hasRecording

### recordingCreated

    protected boolean recordingCreated

### recording

    protected Object recording

### recordingAlreadyReturned

    protected boolean recordingAlreadyReturned

Constructor Detail

### MimicReplayingEntitySelector

    public MimicReplayingEntitySelector(MimicRecordingEntitySelector recordingEntitySelector)

Method Detail

### phaseStarted

    public void phaseStarted(AbstractSolverPhaseScope phaseScope)

  Specified by:
    `phaseStarted` in interface `SolverPhaseLifecycleListener`
  Overrides:
    `phaseStarted` in class `AbstractSelector`

### phaseEnded

    public void phaseEnded(AbstractSolverPhaseScope phaseScope)

  Specified by:
    `phaseEnded` in interface `SolverPhaseLifecycleListener`
  Overrides:
    `phaseEnded` in class `AbstractSelector`

### getEntityDescriptor

    public PlanningEntityDescriptor getEntityDescriptor()

  Returns:
    never null

### isCountable

    public boolean isCountable()

  Description copied from interface: `Selector`
  If false, then `Selector.isNeverEnding()` is true.

  Returns:
    true if all the `ValueRange`s are countable (for example a double value range between 1.2 and 1.4 is not countable)

### isNeverEnding

    public boolean isNeverEnding()

  Description copied from interface: `Selector`
  Is true if `Selector.isCountable()` is false or if this selector is in random order (for most cases). Is never true when this selector is in shuffled order (which is less scalable but more exact).

  Returns:
    true if the `Iterator.hasNext()` of the `Iterator` created by `Iterable.iterator()` never returns false (except when it's empty).

### getSize

    public long getSize()

  Description copied from interface: `IterableSelector`
  A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.

  Returns:
    the approximate number of elements generated by this `Selector`, always >= 0

### iterator

    public Iterator<Object> iterator()

### recordedHasNext

    public void recordedHasNext(boolean hasNext)

### recordedNext

    public void recordedNext(Object next)

### endingIterator

    public Iterator<Object> endingIterator()

  Description copied from interface: `EntitySelector`
  If `Selector.isNeverEnding()` is true, then `Iterable.iterator()` will never end. This returns an ending `Iterator`, that tries to match `Iterable.iterator()` as much as possible, but might not respect the configuration of this `EntitySelector` entirely.

  Returns:
    never null
  See Also:
    `Iterable.iterator()`

### listIterator

    public ListIterator<Object> listIterator()

  Description copied from interface: `ListIterable`
  See `List.listIterator()`

  Returns:
    never null, see `List.listIterator()`.

### listIterator

    public ListIterator<Object> listIterator(int index)

  Description copied from interface: `ListIterable`
  See `List.listIterator()`

  Parameters:
    `index` - lower than the size of this `ListIterable`, see `List.listIterator(int)`.
  Returns:
    never null, see `List.listIterator(int)`.

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.Beta1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2014 JBoss by Red Hat. All Rights Reserved.